(***************************************************************************
 *
 * Index Set Sequence Interface
 *
 * Author: Gerald Baumgartner
 * Date:   1 August 2001
 *
 ***************************************************************************)

signature INDEX_SET_SEQ =
  sig
    eqtype t
    eqtype iSet
    eqtype iSetSeq
    eqtype iSetSeqSet

    exception Incompatible

    val any : iSetSeq
    val set : iSetSeq -> iSet
    val prefix : iSetSeq * iSetSeq -> bool
    val prefixes : iSetSeq -> iSetSeqSet
    val maxPrefix : iSetSeq * iSet -> iSetSeq
    val merge : iSetSeq * iSetSeq -> iSetSeq (* raises Incompatible *)
    val extend : iSetSeq * iSet -> iSetSeq
    val restrict: iSetSeq * iSetSeq -> iSetSeq
    val suffix : iSetSeq * iSetSeq -> iSetSeq
    val leq : iSetSeq * iSetSeq -> bool
    val toString : iSetSeq -> string
  end
