(***************************************************************************
 *
 * Tests for the Index Set Implementation
 *
 * Author: Gerald Baumgartner
 * Date:   3 June 2001
 *
 ***************************************************************************)

structure TestIndexSet =
  struct
    open IndexSet

    val testUnion =
	toString (union (nil, nil)) = ""
	andalso toString (union (["i"], ["i"])) = "i"
	andalso toString (union (["i"], ["j"])) = "ij"
	andalso toString (union (["j"], ["i"])) = "ij"
	andalso toString (union (["i"], ["i", "j"])) = "ij"
	andalso toString (union (["i", "j"], ["i"])) = "ij"
	andalso toString (union (["i", "j"], ["i", "j"])) = "ij"
    val testIntersect =
	toString (intersect (nil, nil)) = ""
	andalso toString (intersect (["i"], ["i"])) = "i"
	andalso toString (intersect (["i"], ["j"])) = ""
	andalso toString (intersect (["j"], ["i"])) = ""
	andalso toString (intersect (["i"], ["i","j"])) = "i"
	andalso toString (intersect (["i","j"], ["i"])) = "i"
	andalso toString (intersect (["i","j"], ["i","j"])) = "ij"
    val testDifference =
	toString (difference (nil, nil)) = ""
	andalso toString (difference (["i"], ["i"])) = ""
	andalso toString (difference (["i"], ["j"])) = "i"
	andalso toString (difference (["j"], ["i"])) = "j"
	andalso toString (difference (["i"], ["i","j"])) = ""
	andalso toString (difference (["i","j"], ["i"])) = "j"
	andalso toString (difference (["i", "j"], ["i", "j"])) = ""
    val testToString =
	toString nil = ""
	andalso toString ["i"] = "i"
	andalso toString ["i", "j"] = "ij"
	andalso toString ["i", "j", "k"] = "ijk"
	andalso toString ["i", "k", "j"] = "ijk"
	andalso toString ["j", "i", "k"] = "ijk"
	andalso toString ["j", "k", "i"] = "ijk"
	andalso toString ["k", "i", "j"] = "ijk"
	andalso toString ["k", "j", "i"] = "ijk"
    val ok =
	testUnion
	andalso testIntersect
	andalso testDifference
	andalso testToString
  end
